/*
 * Copyright (C) 2005  Heinz Mauelshagen, Red Hat GmbH.
 *                     All rights reserved.
 *
 * See file LICENSE at the top of this source tree for license information.
 */

#ifndef _DAEMON_H_
#define _DAEMON_H_

/* Daemon commands. */
enum daemon_cmd_type {
	CMD_UNDEF,
	CMD_ALIVE,
	CMD_MONITOR_START,
	CMD_MONITOR_STOP,
};

enum daemon_status_type {
	STATUS_UNDEF,
	STATUS_OK,
	STATUS_ERR,
};

/* Daemon message definition. */
struct daemon_message {
	union {
		uint8_t	cmd;
		uint8_t status;
	} opcode;
	uint8_t	msg[127];
} __attribute__((packed));

/* Daemon interface. */
struct lib_context;
struct daemon_interface {
	int  (*open)  (struct lib_context *lc);
	void (*close) (struct lib_context *lc);
	int  (*read)  (struct lib_context *lc, struct daemon_message *msg);
	int  (*write) (struct lib_context *lc, struct daemon_message *msg);
	void *private; /* Daemon communication context. */
};

int  register_daemon_interface(struct lib_context *lc);
void unregister_daemon_interface(struct lib_context *lc);

#endif
